<?php

$ci = get_instance();

$config["editor_type"]["residential_sale"] = array(
    "gid"    => "residential_sale",
    "module" => "listings",
    "name"   => "Residential realty (for sale)",
    "tables" => array(
        "listings_residential"            => DB_PREFIX . "listings_residential",
        "listings_residential_moderation" => DB_PREFIX . "listings_residential_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_residential" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["commercial_sale"] = array(
    "gid"    => "commercial_sale",
    "module" => "listings",
    "name"   => "Commerce realty (for sale)",
    "tables" => array(
        "listings_commercial"            => DB_PREFIX . "listings_commercial",
        "listings_commercial_moderation" => DB_PREFIX . "listings_commercial_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_commercial" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["lot_and_land_sale"] = array(
    "gid"    => "lot_and_land_sale",
    "module" => "listings",
    "name"   => "Lots and lands (for sale)",
    "tables" => array(
        "listings_lot_and_land"            => DB_PREFIX . "listings_lot_and_land",
        "listings_lot_and_land_moderation" => DB_PREFIX . "listings_lot_and_land_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'listings_lot_and_land' => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["residential_buy"] = array(
    "gid"    => "residential_buy",
    "module" => "listings",
    "name"   => "Residential realty (for buy)",
    "tables" => array(
        "listings_residential"            => DB_PREFIX . "listings_residential",
        "listings_residential_moderation" => DB_PREFIX . "listings_residential_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_residential" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["commercial_buy"] = array(
    "gid"    => "commercial_buy",
    "module" => "listings",
    "name"   => "Commerce realty (for buy)",
    "tables" => array(
        "listings_commercial"            => DB_PREFIX . "listings_commercial",
        "listings_commercial_moderation" => DB_PREFIX . "listings_commercial_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_commercial" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["lot_and_land_buy"] = array(
    "gid"    => "lot_and_land_buy",
    "module" => "listings",
    "name"   => "Lots and lands (for buy)",
    "tables" => array(
        "listings_lot_and_land"            => DB_PREFIX . "listings_lot_and_land",
        "listings_lot_and_land_moderation" => DB_PREFIX . "listings_lot_and_land_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'listings_lot_and_land' => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["residential_rent"] = array(
    "gid"    => "residential_rent",
    "module" => "listings",
    "name"   => "Residential realty (for rent)",
    "tables" => array(
        "listings_residential"            => DB_PREFIX . "listings_residential",
        "listings_residential_moderation" => DB_PREFIX . "listings_residential_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_residential" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["commercial_rent"] = array(
    "gid"    => "commercial_rent",
    "module" => "listings",
    "name"   => "Commerce realty (for rent)",
    "tables" => array(
        "listings_commercial"            => DB_PREFIX . "listings_commercial",
        "listings_commercial_moderation" => DB_PREFIX . "listings_commercial_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_commercial" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["lot_and_land_rent"] = array(
    "gid"    => "lot_and_land_rent",
    "module" => "listings",
    "name"   => "Lots and lands (for rent)",
    "tables" => array(
        "listings_lot_and_land"            => DB_PREFIX . "listings_lot_and_land",
        "listings_lot_and_land_moderation" => DB_PREFIX . "listings_lot_and_land_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'listings_lot_and_land' => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["residential_lease"] = array(
    "gid"    => "residential_lease",
    "module" => "listings",
    "name"   => "Residential realty (for lease)",
    "tables" => array(
        "listings_residential"            => DB_PREFIX . "listings_residential",
        "listings_residential_moderation" => DB_PREFIX . "listings_residential_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_residential" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["commercial_lease"] = array(
    "gid"    => "commercial_lease",
    "module" => "listings",
    "name"   => "Commerce realty (for lease)",
    "tables" => array(
        "listings_commercial"            => DB_PREFIX . "listings_commercial",
        "listings_commercial_moderation" => DB_PREFIX . "listings_commercial_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        "listings_commercial" => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["lot_and_land_lease"] = array(
    "gid"    => "lot_and_land_lease",
    "module" => "listings",
    "name"   => "Lots and lands (for lease)",
    "tables" => array(
        "listings_lot_and_land"            => DB_PREFIX . "listings_lot_and_land",
        "listings_lot_and_land_moderation" => DB_PREFIX . "listings_lot_and_land_moderation",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'listings_lot_and_land' => 'search_field',
    ),
    'fulltext_foreign_key' => 'id_listing',
    'fulltext_model'       => "Listings_model",
    'fulltext_callback'    => "get_fulltext_data",
);

$config["editor_type"]["user"] = array(
    "gid"    => "user",
    "module" => "users",
    "name"   => "Users",
    "tables" => array(
        "users" => DB_PREFIX . "users",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'users' => 'search_field',
    ),
    'fulltext_model'    => "Users_model",
    'fulltext_callback' => "get_fulltext_data",
);

if ($ci->pg_module->is_module_active("users_private")) {
    $users_private_enabled = true;
} elseif (defined('USERS_PRIVATE_INSTALLING')) {
    $users_private_enabled = true;
} else {
    $users_private_enabled = false;
}

if ($users_private_enabled) {
    $config["editor_type"]["private"] = array(
        "gid"    => "private",
        "module" => "users",
        "name"   => "Private persons",
        "tables" => array(
            "users" => DB_PREFIX . "users",
        ),
        "field_prefix"   => 'fe_',
        'fulltext_use'   => true,
        'fulltext_field' => array(
            'users' => 'search_field',
        ),
        'fulltext_model'    => "Users_model",
        'fulltext_callback' => "get_fulltext_data",
    );
}

$config["editor_type"]["company"] = array(
    "gid"    => "company",
    "module" => "users",
    "name"   => "Agencies",
    "tables" => array(
        "users" => DB_PREFIX . "users",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'users' => 'search_field',
    ),
    'fulltext_model'    => "Users_model",
    'fulltext_callback' => "get_fulltext_data",
);

$config["editor_type"]["agent"] = array(
    "gid"    => "agent",
    "module" => "users",
    "name"   => "Agents",
    "tables" => array(
        "users" => DB_PREFIX . "users",
    ),
    "field_prefix"   => 'fe_',
    'fulltext_use'   => true,
    'fulltext_field' => array(
        'users' => 'search_field',
    ),
    'fulltext_model'    => "Users_model",
    'fulltext_callback' => "get_fulltext_data",
);
