<?php

namespace Pg\Libraries\Analytics\Integrations;

class Google
{

    const HOST = 'http://www.google-analytics.com/collect ';
    const SOURCE_CAMPAING = 'DatingPro';
    const CHANNEL_CAMPAING = 'Market';

    /**
     *Google API key
     *
     * @var string
     */
    private $api_key = 'UA-43414725-1';
    private $ci;

    /**
     * Google construct
     *
     * @return Google
     */
    public function __construct()
    {
        $this->ci = &get_instance();
        if ($this->ci->pg_module->is_module_installed('seo_advanced') && !$_ENV['DEMO_MODE']) {
            $this->api_key = $this->ci->pg_module->get_module_config('seo_advanced', 'seo_ga_default_account_id');
        }
    }

    /**
     * Track
     *
     * @param type $event
     */
    public function track($event)
    {
        $this->sendEvent($event);
    }

    /**
     * Send event
     *
     * @param type $event
     */
    public function sendEvent($event)
    {
        $data   = [
            'v' => '1',
            't' => 'event',
            'cs' => self::SOURCE_CAMPAING,
            'cm' => self::CHANNEL_CAMPAING,
            'tid' => $this->api_key,
            'cid' => $this->ci->analytics->identify_id,
            'uip' => $this->ci->input->server('REMOTE_ADDR'),
            'ua' => $this->ci->agent->agent,
            'ec' => $this->ci->analytics->getEventCategory($event),
            'ea' => $event,
            'el' => $this->ci->analytics->getEventType(),
        ];
        $fields = $this->createUrl($data);

        $this->sendRequest($fields);
    }

    /**
     * Get API key
     *
     * @return string
     */
    public function getApiKey()
    {
        return $this->api_key;
    }

    /**
     * Create url
     *
     * @param array $data
     *
     * @return string
     */
    private function createUrl($data = [])
    {
        $str = '';
        foreach ($data as $key => $val) {
            if (!$str) {
                $prefix = '';
            } else {
                $prefix = '&';
            }

            $str .= $prefix . $key . '=' . urlencode($val);
        }

        return $str;
    }

    /**
     * Send request
     *
     * @param array $data
     *
     * @return void
     */
    private function sendRequest($data = [])
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_URL, self::HOST);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_exec($ch);
    }
}