<?php

namespace Pg\Modules\Currencies\Controllers;

/**
 * Currencies module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Currencies api controller
 *
 * @package 	PG_RealEstate
 * @subpackage 	Currencies
 *
 * @category	controllers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Api_Currencies extends \Controller
{

    /**
     * Get payment form
     *
     * @param string $currency_gid currency guid (post)
     * @param string $system_gid   payment system guid (post)
     *
     * @return void
     */
    public function form()
    {
        $data['currency_gid'] = $this->input->post('currency_gid', true);
        $data['system_gid'] = $this->input->post('system_gid', true);
        if (!$data['system_gid']) {
            log_message('error', 'currencies API: Empty system gid');
            $this->set_api_content('errors', l('error_system_gid_incorrect', 'currencies'));
            return false;
        }
        if (!$data['currency_gid']) {
            log_message('error', 'currencies API: Empty currency gid');
            $this->set_api_content('errors', l('error_currency_code_incorrect', 'currencies'));
            return false;
        }

        $this->load->model('payments/models/Payment_systems_model');
        $data['system'] = $this->Payment_systems_model->get_system_by_gid($data['system_gid']);
        $this->Payment_systems_model->load_driver($data['system_gid']);
        $data['map'] = $this->Payment_systems_model->get_html_data_map();

        $this->load->model('Currencies_model');
        $data['currency'] = $this->Currencies_model->get_currency_by_gid($data["currency_gid"]);

        $this->set_api_content('data', $data);
    }

}
