<?php

return [
    'dynamic_blocks' => [
        [
            'gid' => 'google_map_block',
            'module' => 'dynamic_block_map',
            'model' => 'Dynamic_block_map_model',
            'method' => '_dynamic_block_get_google_map',
            'min_width' => 100,
            'params' => [
                'count' => ['gid' => 'count', 'type' => 'int', 'default' => 50,],
                'search_form' => ['gid' => 'search_form', 'type' => 'checkbox', 'default' => true,],
            ],
            'views' => [
                //['gid' => 'latest_added_980_440'],
                ['gid' => 'latest_added_1600_440'],
                //['gid' => 'sale_980_440'],
                ['gid' => 'sale_1600_440'],
                //['gid' => 'rent_980_440'],
                ['gid' => 'rent_1600_440'],
                //['gid' => 'sold_980_440'],
                ['gid' => 'sold_1600_440'],
            ],
            'area' => [
                'gid' => 'index-page',
                'params' => ['count' => 50],
                'view_str' => 'latest_added_1600_440',
                'width' => 100,
                'cache_time' => 0,
                'sorter' => 1,
            ],
            'presets' => [
                [
                    'gid_preset' => 'default',
                    'gid_area' => 'index-page',
                    'params' => ['count' => 50],
                    'view_str' => 'latest_added_1600_440',
                    'width' => 100,
                    'cache_time' => 0,
                    'sorter' => 8,
                ],
                [
                    'gid_preset' => 'custom',
                    'gid_area' => 'index-page',
                    'params' => ['count' => 50],
                    'view_str' => 'latest_added_1600_440',
                    'width' => 100,
                    'cache_time' => 0,
                    'sorter' => 1,
                ],
            ],
        ],
    ],
    'geomap' => [
        [
            'map_gid' => 'googlemapsv3',
            'id_user' => 0,
            'id_object' => 0,
            'zoom' => 14,
            'gid' => 'listing_dynamic_block',
            'use_type_selector' => 1,
            'use_panorama' => 0,
            'use_router' => 0,
            'use_searchbox' => 0,
            'use_search_radius' => 0,
            'use_search_auto' => 0,
            'use_show_details' => 0,
            'use_smart_zoom' => 0,
            'use_geotargetting' => 0,
            'markers_show_square' => 10,
            'use_clusterer' => 1,
            'use_amenities' => 0,
            'amenities' => [],
            'rent_marker_color' => '4ACC1B',
            'sale_marker_color' => 'FA1E1E',
            'sold_marker_color' => 'FFFFFF',
            'lat' => 40.7142700,
            'lon' => -74.0059700,
            'control_position' => array('top' => true, 'right' => true),
        ],
    ],
];
