function ImportAdmin(optionArr){
	this.properties = {
		siteUrl: '',
		urlSettingsForm: 'admin/import/ajax_get_settings',
		importFormId: 'import_form',
		driverSelectId: 'driver_select',
		driverSettingsId: 'driver_box',
		driverSettingsClass: 'settings-update',
		uploadFormId: 'upload',
		schedulerFormId: 'scheduler',
		inputTypeId: 'input_type',
		inputTypesId: 'input_types',
	};
	
	var _self = this;

	this.Init = function(options){
		_self.properties = $.extend(_self.properties, options);	
		
		$('#'+_self.properties.importFormId).off('change', '#'+_self.properties.driverSelectId).on('change', '#'+_self.properties.driverSelectId, function(){
			_self.get_driver_settings();
			return false;
		});
		
		$('#'+_self.properties.importFormId).off('change', '.'+_self.properties.driverSettingsClass).on('change', '.'+_self.properties.driverSettingsClass, function(){
			_self.get_driver_settings();
			return false;
		});
	}
	
	this.get_driver_settings = function(){
		var data = $('#'+_self.properties.importFormId).serializeArray();
		$.ajax({
			url: _self.properties.siteUrl + _self.properties.urlSettingsForm, 
			method: 'post',
			data: data,
			dataType: 'json',
			success: function(data){
				if(parseInt(data.is_upload)){
					$('#'+_self.properties.uploadFormId).show();
				}else{
					$('#'+_self.properties.uploadFormId).hide();
				}
				
				if(parseInt(data.is_integration)){
					$('#'+_self.properties.schedulerFormId).show();
				}else{
					$('#'+_self.properties.schedulerFormId).hide();
				}
				
				if(Object.keys(data.input_types)){
					var input_types = $('#'+_self.properties.inputTypeId);
					input_types.empty();
					$.each(data.input_types, function(index, name) {
						input_types.append($("<option />").val(index).text(name));
					});
					if(Object.keys(data.input_types) > 1){
						$('#'+_self.properties.inputTypesId).show();
					}else{
						$('#'+_self.properties.inputTypeId).hide();
					}
				}
				
				$('#'+_self.properties.driverSettingsId).html(data.settings);
			}
		});
	}
	
	_self.Init(optionArr);
}
