<?php

namespace Pg\Modules\Language_identification\Models;

/**
 * Language_identification module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * Base model
 *
 * @package 	PG_RealEstate
 * @subpackage 	Language_identification
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Language_identification_model extends \Model
{

    /**
     * Module GUID
     *
     * @var string
     */
    const MODULE_GID = 'language_identification';

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $ci;

    /**
     * Settings for formatting language identification object
     *
     * @var array
     */
    protected $format_settings = array(
        'automatic_identification' => true,
    );

    /**
     * Class constructor
     *
     * @return Language_identification_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->ci = &get_instance();
    }

    /**
     * Change settings for formatting language identification object
     *
     * @param string $name  parameter name
     * @param mixed  $value parameter value
     *
     * @return void
     */
    public function setFormatSettings($name, $value = false)
    {
        if (!is_array($name)) {
            $name = array($name => $value);
        }
        foreach ($name as $key => $item) {
            $this->format_settings[$key] = $item;
        }
    }

}
