<?php

return [
    'menu' => [
        "admin_menu" => [
            "action" => "none",
            "items" => [
                "main_items" => [
                    "action" => "none",
                    "items" => [
                        'payments_menu_item' => ['action' => 'update', 'link' => 'admin/payments', 'icon' => 'money', 'status' => 1, 'sorter' => 4, 'indicator_gid' => 'new_payment_item'],
                    ],
                ],
            ],
        ],
        'admin_payments_menu' => [
            'action' => 'create',
            'name' => 'Admin mode - Payments',
            'items' => [
                'systems_list_item' => ['action' => 'create', 'link' => 'admin/payments/systems', 'status' => 1],
                'payments_list_item' => ['action' => 'create', 'link' => 'admin/payments/index', 'status' => 1],
            ],
        ],
        'private_account_menu' => [
            'action' => 'none',
            'items' => [
                'private_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'private_my_payments_item' => ['action' => 'create', 'link' => 'payments/statistic', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'company_account_menu' => [
            'action' => 'none',
            'items' => [
                'company_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'company_my_payments_item' => ['action' => 'create', 'link' => 'payments/statistic', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'agent_account_menu' => [
            'action' => 'none',
            'items' => [
                'agent_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'agent_my_payments_item' => ['action' => 'create', 'link' => 'payments/statistic', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'private_slide_profile_menu' => [
            'action' => 'none',
            'items' => [
                'private_payments_item' => [
                    'action' => 'create',
                    'status' => 1,
                    'sorter' => 4,
                    'items' => [
                        'private_my_payments_item' => ['action' => 'create', 'link' => 'payments/index', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'company_slide_profile_menu' => [
            'action' => 'none',
            'items' => [
                'company_payments_item' => [
                    'action' => 'create',
                    'status' => 1,
                    'sorter' => 4,
                    'items' => [
                        'company_my_payments_item' => ['action' => 'create', 'link' => 'payments/index', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'agent_slide_profile_menu' => [
            'action' => 'none',
            'items' => [
                'agent_payments_item' => [
                    'action' => 'create',
                    'status' => 1,
                    'sorter' => 4,
                    'items' => [
                        'agent_my_payments_item' => ['action' => 'create', 'link' => 'payments/index', 'status' => 1, 'sorter' => 3],
                    ],
                ],
            ],
        ],
        'company_payments_menu' => [
            'action' => 'create',
            'name' => 'Payments menu for companies',
            'items' => [
                'company_payments_statistic' => [
                    'action' => 'create',
                    'link' => 'payments/statistic',
                    'status' => 1,
                    'sorter' => 3,
                ],
            ],
        ],
        'agent_payments_menu' => [
            'action' => 'create',
            'name' => 'Payments menu for agents',
            'items' => [
                'agent_payments_statistic' => [
                    'action' => 'create',
                    'link' => 'payments/statistic',
                    'status' => 1,
                    'sorter' => 3,
                ],
            ],
        ],
    ],
    'menu_indicators' => [
        [
            'gid' => 'new_payment_item',
            'delete_by_cron' => false,
            'auth_type' => 'admin',
        ],
    ],
    'moderators_methods' => [
        ['module' => 'payments', 'method' => 'index', 'is_default' => 1],
        ['module' => 'payments', 'method' => 'systems', 'is_default' => 0],
        ['module' => 'payments', 'method' => 'settings', 'is_default' => 0],
    ],
    'notifications' => [
        "templates" => [
            ["gid" => "payment_status_updated", "name" => "Payment status updated", "vars" => ["user", "payment", "status"], "content_type" => "text"],
        ],
        "notifications" => [
            ["gid" => "payment_status_updated", "template" => "payment_status_updated", "send_type" => "simple"],
        ],
    ],
    'lang_dm_data' => [
        [
            "module" => "payments",
            "model" => "Payment_systems_model",
            "method_add" => "lang_dedicate_module_callback_add",
            "method_delete" => "lang_dedicate_module_callback_delete",
        ],
    ],
];
