DROP TABLE IF EXISTS `[prefix]payments`;
CREATE TABLE IF NOT EXISTS `[prefix]payments` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `payment_type_gid` varchar(20) NOT NULL,
  `id_user` int(3) NOT NULL,
  `amount` float NOT NULL,
  `currency_gid` varchar(5) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `system_gid` varchar(20) NOT NULL,
  `date_add` datetime NOT NULL,
  `date_update` datetime NOT NULL,
  `payment_data` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `payment_type_gid` (`payment_type_gid`,`id_user`,`status`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]payments_log`;
CREATE TABLE IF NOT EXISTS `[prefix]payments_log` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `system_gid` varchar(20) NOT NULL,
  `log_type` varchar(10) NOT NULL,
  `payment_data` text NOT NULL,
  `date_add` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[prefix]payments_systems`;
CREATE TABLE IF NOT EXISTS `[prefix]payments_systems` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `gid` varchar(20) NOT NULL,
  `name` varchar(50) NOT NULL,
  `settings_data` text NOT NULL,
  `is_test` tinyint(3) NOT NULL,
  `in_use` tinyint(3) NOT NULL,
  `tarifs_type` tinyint(4) NOT NULL,
  `tarifs_editable` tinyint(1) NOT NULL,
  `tarifs_status` text NOT NULL,
  `tarifs_data` text NOT NULL,
  `disable` int(3) NOT NULL,
  `date_add` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `gid` (`gid`),
  KEY `in_use` (`in_use`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `[prefix]payments_systems` VALUES(NULL, 'offline', 'Offline payment', '', 0, 1, 0, 0, '', '', 4, '2011-05-18 11:36:00');

DROP TABLE IF EXISTS `[prefix]payments_type`;
CREATE TABLE IF NOT EXISTS `[prefix]payments_type` (
  `id` tinyint(1) NOT NULL AUTO_INCREMENT,
  `gid` varchar(30) NOT NULL,
  `callback_module` varchar(50) NOT NULL,
  `callback_model` varchar(50) NOT NULL,
  `callback_method` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
