<?php

/**
 * Subscriptions module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Subscriptions management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Subscriptions
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('get_user_subscriptions_form')) {
    /**
     * Get subscribe form
     *
     * @param string $place page placement
     *
     * @return string
     */
    function get_user_subscriptions_form($place, $user_type = null)
    {
        $ci = &get_instance();
        $ci->load->model('Subscriptions_model');
        $ci->load->model('subscriptions/models/Subscriptions_users_model');
        $params = array();
        $user_id = $ci->session->userdata("user_id");
        $user_subscription = $ci->Subscriptions_users_model->get_subscriptions_by_id_user($user_id);

        $ci->load->model('Users_model');

        $query = "subscribe_type = " . $ci->db->escape('user') . " AND (subscriber_type=" . $ci->db->escape('all') . " OR";

        if ($user_type) {
            $query .= " subscriber_type=" . $ci->db->escape($user_type);
        } else {
            $subscriber_types = $ci->Users_model->getUserTypes();
            foreach ($subscriber_types as $user_type) {
                $query .= " subscriber_type=" . $ci->db->escape($user_type) . " OR";
            }
            $query = mb_substr($query, 0, -3);
        }

        $query .= ')';

        $params['where_sql'][] = $query;

        $subscriptions_list = $ci->Subscriptions_model->get_subscriptions_list(null, null, null, $params);
        foreach ($subscriptions_list as $key => $subcription) {
            if (isset($user_subscription[$subcription['id']])) {
                $subscriptions_list[$key]['subscribed'] = 1;
            }
        }
        $ci->view->assign('subscriptions_list', $subscriptions_list);
        return $ci->view->fetch('helper_form_' . $place, 'user', 'subscriptions');
    }
}
if (!function_exists('get_user_subscriptions_list')) {
    /**
     * Get subscriptions data
     *
     * @param string $user_type user type
     *
     * @return string
     */
    function get_user_subscriptions_list($user_type = null)
    {
        $ci = &get_instance();
        $ci->load->model('Subscriptions_model');
        $ci->load->model('subscriptions/models/Subscriptions_users_model');

        $user_id = $ci->session->userdata('user_id');
        $user_type = $ci->session->userdata('user_type');

        $query = "subscribe_type = " . $ci->db->escape('user') . " AND (subscriber_type=" . $ci->db->escape('all') . " OR";

        if ($user_type) {
            $query .= " subscriber_type='" . $user_type . "'";
        } else {
            $subscriber_types = $ci->Users_model->getUserTypes();
            foreach ($subscriber_types as $user_type) {
                $query .= " subscriber_type=" . $ci->db->escape($user_type) . " OR";
            }
            $query = mb_substr($query, 0, -3);
        }

        $query .= ')';

        $params = array();
        $params['where_sql'][] = $query;
        $subscriptions_list = $ci->Subscriptions_model->get_subscriptions_list(null, null, null, $params);
        if ($user_id) {
            $user_subscription = $ci->Subscriptions_users_model->get_subscriptions_by_id_user($user_id);
            foreach ($subscriptions_list as $key => $subcription) {
                if (isset($user_subscription[$subcription['id']])) {
                    $subscriptions_list[$key]['subscribed'] = 1;
                }
            }
        }

        if (empty($subscriptions_list)) {
            return;
        }

        $ci->view->assign('subscriptions_list', $subscriptions_list);
        return $ci->view->fetch('user_subscription_list', 'user', 'subscriptions');
    }
}
