<?php

/**
 * Uploads module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Uploads management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Uploads
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists("uploader_block")) {
    /**
     * Return uploader block
     *
     * @param array $params block parameters
     *
     * @return string
     */
    function uploader_block($params)
    {
        $ci = &get_instance();
        if (!isset($params["url"]) || empty($params["url"])) {
            return false;
        }
        if (!isset($params["field_name"]) || empty($params["field_name"])) {
            return false;
        }

        $ci->view->assign("upload_url", $params["url"]);
        $ci->view->assign("field_name", $params["field_name"]);

        $form_id = '';
        if (isset($params["form_id"])) {
            $form_id = $params["form_id"];
        }
        $ci->view->assign("uploader_form_id", $form_id);

        $callback = '';
        if (!isset($params["callback"])) {
            $callback = $params["callback"];
        }
        $ci->view->assign("uploader_callback", $params["callback"]);

        $max_file_size = 100000000;
        if (isset($params["max_file_size"])) {
            $max_file_size = $params["max_file_size"];
        }
        $ci->view->assign("max_file_size", $max_file_size);

        $use_drop_zone = true;
        if (isset($params["use_drop_zone"])) {
            $use_drop_zone = $params["use_drop_zone"];
        }
        $ci->view->assign("use_drop_zone", $use_drop_zone);

        $rand = rand(100000, 999999);
        $ci->view->assign("uploader_rand", $rand);
        return $ci->view->fetch("helper_uploader_block", null, "uploads");
    }
}
