<?php

/**
 * Users payments module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
/**
 * Users payments management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Users payments
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('update_account_block')) {

    /**
     * Return add funds to account block
     *
     * @return string
     */
    function update_account_block()
    {
        $ci = &get_instance();

        $payment_sections = array('account');

        $ci->load->library('mobile_detect');
        
        // TODO: разделение на мобильные и десктоп
        /*if ($ci->mobile_detect->isMobile()) {
            $payment_sections[] = 'mobile';
        } else {
            $payment_sections[] = 'desktop';
        }*/
        
        $payment_sections[] = 'desktop';
        
        $ci->load->model("Users_model");
        $account = $ci->Users_model->get_user_account($ci->session->userdata("user_id"));
        $ci->view->assign('user_account', $account);

        $is_install_payments = $ci->pg_module->is_module_active('payments');
        if ($is_install_payments) {
            $ci->load->model("payments/models/Payment_systems_model");
            $billing_systems = $ci->Payment_systems_model->get_active_system_list(array("name" => "ASC"), $payment_sections);
            $ci->view->assign('billing_systems', $billing_systems);
        }

        $ci->load->model("Currencies_model");
        $base_currency = $ci->Currencies_model->get_currency_default(true);
        $ci->view->assign('base_currency', $base_currency);

        $base_currency_gid = $ci->pg_module->get_module_config("start", "base_currency");
        $ci->view->assign("base_currency_gid", $base_currency_gid);

        return $ci->view->fetch('helper_update_account', 'user', 'users_payments');
    }
}

if (!function_exists('add_funds_button')) {

    /**
     * Return button for adding funds
     *
     * @return string
     */
    function button_add_funds()
    {
        $ci = &get_instance();

        $ci->load->model("Currencies_model");
        $base_currency = $ci->Currencies_model->get_currency_default(true);
        $ci->view->assign('base_currency', $base_currency);

        return $ci->view->fetch('helper_add_funds', 'admin', 'users_payments');
    }
}

if (!function_exists('user_account')) {

    /**
     * Return account value
     *
     * @return string
     */
    function user_account()
    {
        $ci = &get_instance();
        if ('user' != $ci->session->userdata("auth_type")) {
            return false;
        }
        $ci->load->model("Users_model");
        $account = $ci->Users_model->get_user_account($ci->session->userdata("user_id"));
        $ci->view->assign('user_account', $account);

        $ci->load->model("Currencies_model");
        $base_currency = $ci->Currencies_model->get_currency_default(true);
        $ci->view->assign('base_currency', $base_currency);

        $base_currency_gid = $ci->pg_module->get_module_config("start", "base_currency");
        $ci->view->assign("base_currency_gid", $base_currency_gid);

        return $ci->view->fetch('helper_account', 'user', 'users_payments');
    }
}

if (!function_exists('user_account_block')) {

    /**
     * Return account block
     *
     * @param array $params block parameters
     *
     * @return string
     */
    function user_account_block($params = [])
    {
        $ci = &get_instance();
        if ('user' != $ci->session->userdata("auth_type")) {
            return false;
        }
        $ci->load->model("Users_model");
        $account = $ci->Users_model->get_user_account($ci->session->userdata("user_id"));
        $ci->view->assign('user_account', $account);

        $ci->load->model("Currencies_model");
        $base_currency = $ci->Currencies_model->get_currency_default(true);
        $ci->view->assign('base_currency', $base_currency);

        $base_currency_gid = $ci->pg_module->get_module_config("start", "base_currency");
        $ci->view->assign("base_currency_gid", $base_currency_gid);

        $ci->view->assign('template', get($params['template']));

        return $ci->view->fetch('helper_account_block', 'user', 'users_payments');
    }
}
