<?php

namespace Pg\Modules\Video_uploads\Controllers;

/**
 * Video uploads module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Video uploads user side controller
 *
 * @package PG_RealEstate
 * @subpackage Video uploads
 *
 * @category	controllers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Video_Uploads extends \Controller
{

    /**
     * Constructor
     *
     * @return Video_Uploads
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Test loading embed code
     *
     * @return void
     */
    public function index()
    {
        $this->embed_test();
    }

    /**
     * Test loading embed code
     *
     * @return void
     */
    public function embed_test()
    {
        $this->load->library('VideoEmbed');

        if ($this->input->post('btn_save')) {
            $data["embed"] = $this->input->post('embed');
            $this->view->assign('data', $data);

            $video_data = $this->videoembed->get_video_data($data["embed"]);
            if ($video_data !== false) {
                $video_data["string_to_save"] = $this->videoembed->get_string_from_video_data($video_data);
                $this->view->assign('video_data', $video_data);

                $embed = $this->videoembed->get_embed_code($video_data);
                $this->view->assign('embed', $embed);
            }
        }
        $services = $this->videoembed->get_services($services);
        $this->view->assign('services', $services);

        $this->view->render('embed_test');
    }

}
